//Bateau.cc

#include "Bateau.h"

Bateau::Bateau()
{
  longueur=0;
}

Bateau::Bateau(short xdeb, short ydeb, bool vert, short lng)
{
  xdebut=xdeb;
  ydebut=ydeb;
  vertical=vert;
  longueur=lng;
  longVivant=longueur;
}

Bateau::~Bateau()
{

}

short Bateau::bombarde()
{
  //on prsume que les coordonnes sont bien sur ce bateau, et pas  un endroit dj touch
  longVivant--;
  if (longVivant>0) return TOUCHE;
  else return COULE;
}

bool Bateau::isDedans(short x, short y)
{
  return ((vertical && (x==xdebut) && (y>=ydebut) && (y<(ydebut+longueur))) //bateau vertical
  || ((!vertical) &&(y==ydebut) && (x>=xdebut) && (x<(xdebut+longueur)))); //bateau horizontal
}

short Bateau::getX()
{
  return xdebut;
}

short Bateau::getY()
{
  return ydebut;
}

bool Bateau::isVertical()
{
  return vertical;
}

bool Bateau::isCoule()
{
  return (longVivant<=0);
}

short Bateau::getType()
{
  return longueur;
}

string Bateau::toString()
{
  return toString(longueur);
}

string Bateau::toString(short modele)
{
  switch (modele)
  {
    case PORTE_AVION: return "Porte-Avions"; break;
    case SOUS_MARIN: return "Sous-Marin"; break;
    case CUIRASSE: return "Cuirass"; break;
    case PNEUMATIQUE: return "Pneumatique"; break;
    default: return "erreur";
  }
}
