//Bateau.h

#ifndef BATEAU_H
#define BATEAU_H
#include "utilitaires.h"

const short INCONNU = 0;
const short BATEAU = 6;
const short TOUCHE = 7;
const short COULE = 8;
const short EAU = 9;

const short PORTE_AVION = 5;
const short SOUS_MARIN = 4;
const short CUIRASSE = 3;
const short PNEUMATIQUE = 2;

class Bateau
{
  private:
    short xdebut;
    short ydebut;
    bool vertical;
    short longueur;
    short longVivant;
  protected:
  public:
    Bateau();
    Bateau(short xdeb, short ydeb, bool vert, short lng);
    ~Bateau();
    short bombarde();
    bool isDedans(short x, short y);
    bool isVertical();
    bool isCoule();
    short getX();
    short getY();
    short getType();
    string toString();
    static string toString(short modele);
};
#endif

