#ifndef SOCKDIST_H
#define SOCKDIST_H
#include <netinet/in.h>//struct in_addr et sockaddr_in
#include <netdb.h>//struct hostent, servent, et fonctions get..by...
#include <arpa/inet.h>//diverses conversions d'adresses

class SockDist{
 private:
  static const int sDom = AF_INET;//domaine adresses
  int sRetour;//retour
  int sLen;//longeur de la struct sockaddr_in rendue
  struct sockaddr_in *adrDist;//la struct interne qui contient le triplet


  void initparam();


 public:
  SockDist();//pour la reception avec adresse inconnue

  SockDist(const char * nomHote, const char * nomServ,
			 const char *protoServ);

  SockDist(const char *nomHote, short numPort);

  ~SockDist();

  sockaddr_in * getAdrDist();

  int getsLen();
};
#endif







