//Utilitaires.cc

#include "utilitaires.h"
//#include <string.h>
#include <stdio.h>
#include <math.h> //pour le log

//cre une nouvelle String  0 terminal de la longueur spcifie
char * newString(short longueur)
{
 char * chaine=new char[longueur+1];
 chaine[longueur]='\0';
 return chaine;
}

char * strToChar(string texte)
{
  char * temp = newString(texte.length());
  for (int cpt=0; cpt<texte.length(); cpt++) temp[cpt]=texte[cpt];
  return temp;
  //return (char *)texte.data();
}

string charToStr(char * texte)
{
  return texte;
}

string strReplace(string chaine, char orig, char par)
{
  for (int cpt=0; cpt<chaine.length(); cpt++)
    if (chaine[cpt]==orig) chaine[cpt]=par;
  return chaine;
}

string strPrefixe(string chaine, int curseur, char jusqua)
{
  string temp="";
  while ((chaine[curseur]!=jusqua)&&(curseur<chaine.length()))
  {
    temp+=chaine[curseur];
    curseur++;
  }
  return temp;
}

short alphaToNum(char lettre)
{
  return (lettre>=97) ? short(lettre-96) : short(lettre-64);
}

string numToAlpha(short lettre)
{
  switch (lettre)
  {
    case 1: return "A"; break;
    case 2: return "B"; break;
    case 3: return "C"; break;
    case 4: return "D"; break;
    case 5: return "E"; break;
    case 6: return "F"; break;
    case 7: return "G"; break;
    case 8: return "H"; break;
    case 9: return "I"; break;
    case 10: return "J"; break;
    case 11: return "K"; break;
    case 12: return "L"; break;
    case 13: return "M"; break;
    case 14: return "N"; break;
    case 15: return "O"; break;
    case 16: return "P"; break;
    case 17: return "Q"; break;
    case 18: return "R"; break;
    case 19: return "S"; break;
    case 20: return "T"; break;
    case 21: return "U"; break;
    case 22: return "V"; break;
    case 23: return "W"; break;
    case 24: return "X"; break;
    case 25: return "Y"; break;
    case 26: return "Z"; break;
    default: return " ";
  }
}

//retourne en base10 l'entier aInt pass en paramtre
string intToStr(int aInt)
{
 char * Result;
 short longueur;
 if (aInt==0) //si l'entier est nul
 {
  longueur=1;
  Result=newString(longueur);
  Result[0]='0';
 }
 else
 {
  if (aInt<0) //pour un entier ngatif
  {
   longueur=2;
   Result[0]='-';
   aInt=-aInt;
  }
  else longueur=1;
  longueur+=int(log10(aInt)); //calcule le nombre de chiffres en base10
  Result=newString(longueur);
  while (aInt>0)
  {
   Result[longueur-1]=char((aInt % 10)+48);
   aInt=int(aInt/10);
   longueur--;
  }
 }
 return Result;
}

string intToStr(int aInt, int lnMin)
{
  string temp=intToStr(aInt);
  while (temp.length()<lnMin) temp=" "+temp;
  return temp;
}
