//CaseJouee.cc

#include "CaseJouee.h"

CaseJouee::CaseJouee()
{
  etat=INCONNU;
  reset();
}

CaseJouee::~CaseJouee()
{
 reset();
}

void CaseJouee::bombe(string nom, short resultat, string bato)
{
  if (joueurs.length()>0) joueurs+=", ";
  joueurs+=nom;
  if (resultat!=0)
  {
    etat=resultat;
    bateau=bato;
  }
  nbJoueurs++;
}

void CaseJouee::reset()
{
   joueurs="";
   bateau="";
   nbJoueurs=0;
   etat=INCONNU;
}

string CaseJouee::toString()
{
  string temp=joueurs+" ";
  if (nbJoueurs<=1) temp+="a";
  else temp+="ont";
  temp+=" "+etatToString(etat);
  if (etat==COULE) temp+=" un "+bateau;
  return temp;
}

/*string CaseJouee::bateauToString(short modele)
{
  switch (modele)
  {
    case PORTE_AVION: return "Porte-Avions"; break;
    case SOUS_MARIN: return "Sous-Marin"; break;
    case CUIRASSE: return "Cuirass"; break;
    case PNEUMATIQUE: return "Pneumatique"; break;
    default: return "erreur";
  }
}*/

string CaseJouee::etatToString(short aEtat)
{
  switch (aEtat)
  {
    case EAU: return "tir dans l'eau"; break;
    case TOUCHE: return "touch"; break;
    case COULE: return "coul"; break;
    case FLOTTE: return "coul la flotte"; break;
    default: return "erreur";
  }
}

bool CaseJouee::isSet()
{
  //return ((etat==EAU)||(etat==TOUCHE)||(etat==COULE));
  return (etat!=INCONNU);
}
