//ServeurPrive.h

#ifndef SERVEURPRIVE_H
#define SERVEURPRIVE_H

#include "CaseJouee.h"
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <string>

class ServeurPublic; //dclaration avance

class ServeurPrive
{
  private:
    string nomJoueur;
    int num_desc;
    char tamponrcp[920];
    char tamponenv[920];
    ServeurPublic * serveurPublic;
    CaseJouee casesJouees[16][16];
    bool administrateur;
    bool pret;
    bool aJoue;
  protected:
    void arrete(string texte);
    void traiterMessage(char * texte);
    void resetCasesJouees();
  public:
    ServeurPrive(int numdesc, bool administ, ServeurPublic * pere);
    ~ServeurPrive();
    void destroy(bool envoiMessage);
    void envoyerMessage(string texte);
    void envoyerMessage(char * texte);
    void messageRecu();
    void exceptionRecue();
    bool isPret();
    bool isAJoue();
    void resetAJoue();
    void affiche(string texte);
    string getCasesJouees();
    string getNomJoueur();
};
#endif

